!------------------------------------
program model_build


use sep
implicit none
!-------------------------------------
integer					:: n1, n2, n3, n4, n5, i1, i2, i3, i4, i5, k1, k3, k4
real 					:: alpha, pi, z0, d1, d4, zref
real, dimension(:,:,:,:,:), allocatable :: model  


!--------------------------------

!call sep_init(SOURCE)

call sep_init()

call from_history( "n1", n1)
call from_history( "n2", n2)
call from_history( "n3", n3)
call from_history( "n4", n4)
call from_history( "n5", n5)
call from_history( "d1", d1)
call from_history( "d4", d4)
call from_param( "alpha", alpha)
call from_param( "zref", zref)

!call sep_close()

allocate(model(n1,n2,n3,n4,n5)) 

!Reading the data
call sreed("in", model, n1*n2*n3*n4*n5*4)
pi=3.141592653
k1=n1/2;
k3=n3/2;
k4=zref/d4;

! Check that the dipping reflector is entirely in the model
!if (z0+tan(alpha/180*pi)<n4*d4 && z0-tan(alpha/180*pi)>0)

do i1=1,n1
   i4=k4-(tan(alpha*pi/180)*(k1-i1)*d1)/d4
!  write(0,*) i4
   if (i4>0 .AND. i4<n4) model(i1,:,k3,i4,:)=1
end do

call srite("out",model, n1*n2*n3*n4*n5*4)
!call sep_write(model)

! write(0,*) "A"

deallocate(model)
! call exit(0)

end program model_build
